/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM calIAlarm.idl
 */

#ifndef __gen_calIAlarm_h__
#define __gen_calIAlarm_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIVariant; /* forward declaration */

class nsISimpleEnumerator; /* forward declaration */

class calIDateTime; /* forward declaration */

class calIDuration; /* forward declaration */

class calIItemBase; /* forward declaration */

class calIcalComponent; /* forward declaration */


/* starting interface:    calIAlarm */
#define CALIALARM_IID_STR "b8db7c7f-c168-4e11-becb-f26c1c4f5f8f"

#define CALIALARM_IID \
  {0xb8db7c7f, 0xc168, 0x4e11, \
    { 0xbe, 0xcb, 0xf2, 0x6c, 0x1c, 0x4f, 0x5f, 0x8f }}

class NS_NO_VTABLE calIAlarm : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(CALIALARM_IID)

  /**
     * Returns true if this alarm is able to be modified
     */
  /* readonly attribute boolean isMutable; */
  NS_IMETHOD GetIsMutable(PRBool *aIsMutable) = 0;

  /**
     * Makes this alarm immutable.
     */
  /* void makeImmutable (); */
  NS_IMETHOD MakeImmutable(void) = 0;

  /**
     * Make a copy of this alarm. The returned alarm will be mutable.
     */
  /* calIAlarm clone (); */
  NS_IMETHOD Clone(calIAlarm **_retval) = 0;

  /**
     * The item this alarm is related to
     */
  /* attribute calIItemBase item; */
  NS_IMETHOD GetItem(calIItemBase * *aItem) = 0;
  NS_IMETHOD SetItem(calIItemBase * aItem) = 0;

  /**
     * How this alarm is shown. Special values as described in rfc2445 are
     * AUDIO, DISPLAY, EMAIL
     * In addition, custom actions may be defined as an X-Prop, i.e
     * X-SMS.
     *
     * Note that aside from setting this action, the frontend must be able to
     * handle the specified action. Unknown actions WILL NOT be notified for.
     */
  /* attribute AUTF8String action; */
  NS_IMETHOD GetAction(nsACString & aAction) = 0;
  NS_IMETHOD SetAction(const nsACString & aAction) = 0;

  /**
     * The offset between the item's date and the alarm time.
     * Setting an offset unsets any specific absolute date set. This means that
     * the alarmDate attribute will be calculated with the offset and the item's
     * date and be null if no item is set.
     */
  /* attribute calIDuration offset; */
  NS_IMETHOD GetOffset(calIDuration * *aOffset) = 0;
  NS_IMETHOD SetOffset(calIDuration * aOffset) = 0;

  /**
     * The absolute point in time the alarm should fire.
     * Setting the alarmDate will unset any specific offset. This means that
     * the offset attribute will be relative to the item this alarm belongs to,
     * or null if no item is set.
     */
  /* attribute calIDateTime alarmDate; */
  NS_IMETHOD GetAlarmDate(calIDateTime * *aAlarmDate) = 0;
  NS_IMETHOD SetAlarmDate(calIDateTime * aAlarmDate) = 0;

  /**
     * One of the ALARM_RELATED constants below.
     * If an alarmDate was set, changing this influences the offset, and vice
     * versa.
     */
  /* attribute unsigned long related; */
  NS_IMETHOD GetRelated(PRUint32 *aRelated) = 0;
  NS_IMETHOD SetRelated(PRUint32 aRelated) = 0;

  /**
     * The alarm's offset should be based off of the startDate or
     * entryDate (for events and tasks, respectively)
     */
  enum { ALARM_RELATED_START = 0U };

  /**
     * the alarm's offset should be based off of the endDate or
     * dueDate (for events and tasks, respectively)
     */
  enum { ALARM_RELATED_END = 1U };

  /**
     * The last time this alarm was fired and acknowledged by the user
     */
  /* attribute calIDateTime lastAck; */
  NS_IMETHOD GetLastAck(calIDateTime * *aLastAck) = 0;
  NS_IMETHOD SetLastAck(calIDateTime * aLastAck) = 0;

  /**
     * Times the alarm should be repeated. This value is the number of
     * ADDITIONAL alarms, aside from the actual alarm.
     *
     * For the alarm to be valid, if repeat is specified, the repeatOffset
     * attribute MUST also be specified.
     */
  /* attribute unsigned long repeat; */
  NS_IMETHOD GetRepeat(PRUint32 *aRepeat) = 0;
  NS_IMETHOD SetRepeat(PRUint32 aRepeat) = 0;

  /**
     * The duration between the alarm and each subsequent repeat
     *
     * For the alarm to be valid, if repeatOffset is specified, the repeat
     * attribute MUST also be specified.
     */
  /* attribute calIDuration repeatOffset; */
  NS_IMETHOD GetRepeatOffset(calIDuration * *aRepeatOffset) = 0;
  NS_IMETHOD SetRepeatOffset(calIDuration * aRepeatOffset) = 0;

  /**
     * If repeat is specified, this helper returns the first DATETIME the alarm
     * should be repeated on.
     */
  /* readonly attribute calIDateTime repeatDate; */
  NS_IMETHOD GetRepeatDate(calIDateTime * *aRepeatDate) = 0;

  /**
     * The description of the alarm. Not valid for AUDIO alarms.
     */
  /* attribute AUTF8String description; */
  NS_IMETHOD GetDescription(nsACString & aDescription) = 0;
  NS_IMETHOD SetDescription(const nsACString & aDescription) = 0;

  /**
     * The summary of the alarm. Not valid for AUDIO and DISPLAY alarms.
     */
  /* attribute AUTF8String summary; */
  NS_IMETHOD GetSummary(nsACString & aSummary) = 0;
  NS_IMETHOD SetSummary(const nsACString & aSummary) = 0;

  /**
     * Manage Attendee for this alarm. Not valid for AUDIO and DISPLAY alarms.
     */
/**
     * Manage Attachments for this alarm.
     * For EMAIL alarms, more than one attachment can be specified.
     * For AUDIO alarms, one Attachment can be specified.
     * For DISPLAY alarms, attachments are invalid.
     */
/**
     * The ical representation of this VALARM
     */
  /* attribute AUTF8String icalString; */
  NS_IMETHOD GetIcalString(nsACString & aIcalString) = 0;
  NS_IMETHOD SetIcalString(const nsACString & aIcalString) = 0;

  /**
     * The ical component of this VALARM
     */
  /* attribute calIcalComponent icalComponent; */
  NS_IMETHOD GetIcalComponent(calIcalComponent * *aIcalComponent) = 0;
  NS_IMETHOD SetIcalComponent(calIcalComponent * aIcalComponent) = 0;

  /* boolean hasProperty (in AUTF8String name); */
  NS_IMETHOD HasProperty(const nsACString & name, PRBool *_retval) = 0;

  /* nsIVariant getProperty (in AUTF8String name); */
  NS_IMETHOD GetProperty(const nsACString & name, nsIVariant **_retval) = 0;

  /* void setProperty (in AUTF8String name, in nsIVariant value); */
  NS_IMETHOD SetProperty(const nsACString & name, nsIVariant *value) = 0;

  /* void deleteProperty (in AUTF8String name); */
  NS_IMETHOD DeleteProperty(const nsACString & name) = 0;

  /* readonly attribute nsISimpleEnumerator propertyEnumerator; */
  NS_IMETHOD GetPropertyEnumerator(nsISimpleEnumerator * *aPropertyEnumerator) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_CALIALARM \
  NS_IMETHOD GetIsMutable(PRBool *aIsMutable); \
  NS_IMETHOD MakeImmutable(void); \
  NS_IMETHOD Clone(calIAlarm **_retval); \
  NS_IMETHOD GetItem(calIItemBase * *aItem); \
  NS_IMETHOD SetItem(calIItemBase * aItem); \
  NS_IMETHOD GetAction(nsACString & aAction); \
  NS_IMETHOD SetAction(const nsACString & aAction); \
  NS_IMETHOD GetOffset(calIDuration * *aOffset); \
  NS_IMETHOD SetOffset(calIDuration * aOffset); \
  NS_IMETHOD GetAlarmDate(calIDateTime * *aAlarmDate); \
  NS_IMETHOD SetAlarmDate(calIDateTime * aAlarmDate); \
  NS_IMETHOD GetRelated(PRUint32 *aRelated); \
  NS_IMETHOD SetRelated(PRUint32 aRelated); \
  NS_IMETHOD GetLastAck(calIDateTime * *aLastAck); \
  NS_IMETHOD SetLastAck(calIDateTime * aLastAck); \
  NS_IMETHOD GetRepeat(PRUint32 *aRepeat); \
  NS_IMETHOD SetRepeat(PRUint32 aRepeat); \
  NS_IMETHOD GetRepeatOffset(calIDuration * *aRepeatOffset); \
  NS_IMETHOD SetRepeatOffset(calIDuration * aRepeatOffset); \
  NS_IMETHOD GetRepeatDate(calIDateTime * *aRepeatDate); \
  NS_IMETHOD GetDescription(nsACString & aDescription); \
  NS_IMETHOD SetDescription(const nsACString & aDescription); \
  NS_IMETHOD GetSummary(nsACString & aSummary); \
  NS_IMETHOD SetSummary(const nsACString & aSummary); \
  NS_IMETHOD GetIcalString(nsACString & aIcalString); \
  NS_IMETHOD SetIcalString(const nsACString & aIcalString); \
  NS_IMETHOD GetIcalComponent(calIcalComponent * *aIcalComponent); \
  NS_IMETHOD SetIcalComponent(calIcalComponent * aIcalComponent); \
  NS_IMETHOD HasProperty(const nsACString & name, PRBool *_retval); \
  NS_IMETHOD GetProperty(const nsACString & name, nsIVariant **_retval); \
  NS_IMETHOD SetProperty(const nsACString & name, nsIVariant *value); \
  NS_IMETHOD DeleteProperty(const nsACString & name); \
  NS_IMETHOD GetPropertyEnumerator(nsISimpleEnumerator * *aPropertyEnumerator); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_CALIALARM(_to) \
  NS_IMETHOD GetIsMutable(PRBool *aIsMutable) { return _to GetIsMutable(aIsMutable); } \
  NS_IMETHOD MakeImmutable(void) { return _to MakeImmutable(); } \
  NS_IMETHOD Clone(calIAlarm **_retval) { return _to Clone(_retval); } \
  NS_IMETHOD GetItem(calIItemBase * *aItem) { return _to GetItem(aItem); } \
  NS_IMETHOD SetItem(calIItemBase * aItem) { return _to SetItem(aItem); } \
  NS_IMETHOD GetAction(nsACString & aAction) { return _to GetAction(aAction); } \
  NS_IMETHOD SetAction(const nsACString & aAction) { return _to SetAction(aAction); } \
  NS_IMETHOD GetOffset(calIDuration * *aOffset) { return _to GetOffset(aOffset); } \
  NS_IMETHOD SetOffset(calIDuration * aOffset) { return _to SetOffset(aOffset); } \
  NS_IMETHOD GetAlarmDate(calIDateTime * *aAlarmDate) { return _to GetAlarmDate(aAlarmDate); } \
  NS_IMETHOD SetAlarmDate(calIDateTime * aAlarmDate) { return _to SetAlarmDate(aAlarmDate); } \
  NS_IMETHOD GetRelated(PRUint32 *aRelated) { return _to GetRelated(aRelated); } \
  NS_IMETHOD SetRelated(PRUint32 aRelated) { return _to SetRelated(aRelated); } \
  NS_IMETHOD GetLastAck(calIDateTime * *aLastAck) { return _to GetLastAck(aLastAck); } \
  NS_IMETHOD SetLastAck(calIDateTime * aLastAck) { return _to SetLastAck(aLastAck); } \
  NS_IMETHOD GetRepeat(PRUint32 *aRepeat) { return _to GetRepeat(aRepeat); } \
  NS_IMETHOD SetRepeat(PRUint32 aRepeat) { return _to SetRepeat(aRepeat); } \
  NS_IMETHOD GetRepeatOffset(calIDuration * *aRepeatOffset) { return _to GetRepeatOffset(aRepeatOffset); } \
  NS_IMETHOD SetRepeatOffset(calIDuration * aRepeatOffset) { return _to SetRepeatOffset(aRepeatOffset); } \
  NS_IMETHOD GetRepeatDate(calIDateTime * *aRepeatDate) { return _to GetRepeatDate(aRepeatDate); } \
  NS_IMETHOD GetDescription(nsACString & aDescription) { return _to GetDescription(aDescription); } \
  NS_IMETHOD SetDescription(const nsACString & aDescription) { return _to SetDescription(aDescription); } \
  NS_IMETHOD GetSummary(nsACString & aSummary) { return _to GetSummary(aSummary); } \
  NS_IMETHOD SetSummary(const nsACString & aSummary) { return _to SetSummary(aSummary); } \
  NS_IMETHOD GetIcalString(nsACString & aIcalString) { return _to GetIcalString(aIcalString); } \
  NS_IMETHOD SetIcalString(const nsACString & aIcalString) { return _to SetIcalString(aIcalString); } \
  NS_IMETHOD GetIcalComponent(calIcalComponent * *aIcalComponent) { return _to GetIcalComponent(aIcalComponent); } \
  NS_IMETHOD SetIcalComponent(calIcalComponent * aIcalComponent) { return _to SetIcalComponent(aIcalComponent); } \
  NS_IMETHOD HasProperty(const nsACString & name, PRBool *_retval) { return _to HasProperty(name, _retval); } \
  NS_IMETHOD GetProperty(const nsACString & name, nsIVariant **_retval) { return _to GetProperty(name, _retval); } \
  NS_IMETHOD SetProperty(const nsACString & name, nsIVariant *value) { return _to SetProperty(name, value); } \
  NS_IMETHOD DeleteProperty(const nsACString & name) { return _to DeleteProperty(name); } \
  NS_IMETHOD GetPropertyEnumerator(nsISimpleEnumerator * *aPropertyEnumerator) { return _to GetPropertyEnumerator(aPropertyEnumerator); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_CALIALARM(_to) \
  NS_IMETHOD GetIsMutable(PRBool *aIsMutable) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsMutable(aIsMutable); } \
  NS_IMETHOD MakeImmutable(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->MakeImmutable(); } \
  NS_IMETHOD Clone(calIAlarm **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Clone(_retval); } \
  NS_IMETHOD GetItem(calIItemBase * *aItem) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetItem(aItem); } \
  NS_IMETHOD SetItem(calIItemBase * aItem) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetItem(aItem); } \
  NS_IMETHOD GetAction(nsACString & aAction) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAction(aAction); } \
  NS_IMETHOD SetAction(const nsACString & aAction) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetAction(aAction); } \
  NS_IMETHOD GetOffset(calIDuration * *aOffset) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOffset(aOffset); } \
  NS_IMETHOD SetOffset(calIDuration * aOffset) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetOffset(aOffset); } \
  NS_IMETHOD GetAlarmDate(calIDateTime * *aAlarmDate) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAlarmDate(aAlarmDate); } \
  NS_IMETHOD SetAlarmDate(calIDateTime * aAlarmDate) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetAlarmDate(aAlarmDate); } \
  NS_IMETHOD GetRelated(PRUint32 *aRelated) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRelated(aRelated); } \
  NS_IMETHOD SetRelated(PRUint32 aRelated) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRelated(aRelated); } \
  NS_IMETHOD GetLastAck(calIDateTime * *aLastAck) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLastAck(aLastAck); } \
  NS_IMETHOD SetLastAck(calIDateTime * aLastAck) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLastAck(aLastAck); } \
  NS_IMETHOD GetRepeat(PRUint32 *aRepeat) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRepeat(aRepeat); } \
  NS_IMETHOD SetRepeat(PRUint32 aRepeat) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRepeat(aRepeat); } \
  NS_IMETHOD GetRepeatOffset(calIDuration * *aRepeatOffset) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRepeatOffset(aRepeatOffset); } \
  NS_IMETHOD SetRepeatOffset(calIDuration * aRepeatOffset) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRepeatOffset(aRepeatOffset); } \
  NS_IMETHOD GetRepeatDate(calIDateTime * *aRepeatDate) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRepeatDate(aRepeatDate); } \
  NS_IMETHOD GetDescription(nsACString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDescription(aDescription); } \
  NS_IMETHOD SetDescription(const nsACString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDescription(aDescription); } \
  NS_IMETHOD GetSummary(nsACString & aSummary) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSummary(aSummary); } \
  NS_IMETHOD SetSummary(const nsACString & aSummary) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSummary(aSummary); } \
  NS_IMETHOD GetIcalString(nsACString & aIcalString) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIcalString(aIcalString); } \
  NS_IMETHOD SetIcalString(const nsACString & aIcalString) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetIcalString(aIcalString); } \
  NS_IMETHOD GetIcalComponent(calIcalComponent * *aIcalComponent) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIcalComponent(aIcalComponent); } \
  NS_IMETHOD SetIcalComponent(calIcalComponent * aIcalComponent) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetIcalComponent(aIcalComponent); } \
  NS_IMETHOD HasProperty(const nsACString & name, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->HasProperty(name, _retval); } \
  NS_IMETHOD GetProperty(const nsACString & name, nsIVariant **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProperty(name, _retval); } \
  NS_IMETHOD SetProperty(const nsACString & name, nsIVariant *value) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetProperty(name, value); } \
  NS_IMETHOD DeleteProperty(const nsACString & name) { return !_to ? NS_ERROR_NULL_POINTER : _to->DeleteProperty(name); } \
  NS_IMETHOD GetPropertyEnumerator(nsISimpleEnumerator * *aPropertyEnumerator) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPropertyEnumerator(aPropertyEnumerator); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public calIAlarm
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_CALIALARM

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, calIAlarm)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute boolean isMutable; */
NS_IMETHODIMP _MYCLASS_::GetIsMutable(PRBool *aIsMutable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void makeImmutable (); */
NS_IMETHODIMP _MYCLASS_::MakeImmutable()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* calIAlarm clone (); */
NS_IMETHODIMP _MYCLASS_::Clone(calIAlarm **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute calIItemBase item; */
NS_IMETHODIMP _MYCLASS_::GetItem(calIItemBase * *aItem)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetItem(calIItemBase * aItem)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AUTF8String action; */
NS_IMETHODIMP _MYCLASS_::GetAction(nsACString & aAction)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetAction(const nsACString & aAction)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute calIDuration offset; */
NS_IMETHODIMP _MYCLASS_::GetOffset(calIDuration * *aOffset)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetOffset(calIDuration * aOffset)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute calIDateTime alarmDate; */
NS_IMETHODIMP _MYCLASS_::GetAlarmDate(calIDateTime * *aAlarmDate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetAlarmDate(calIDateTime * aAlarmDate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long related; */
NS_IMETHODIMP _MYCLASS_::GetRelated(PRUint32 *aRelated)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetRelated(PRUint32 aRelated)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute calIDateTime lastAck; */
NS_IMETHODIMP _MYCLASS_::GetLastAck(calIDateTime * *aLastAck)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetLastAck(calIDateTime * aLastAck)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long repeat; */
NS_IMETHODIMP _MYCLASS_::GetRepeat(PRUint32 *aRepeat)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetRepeat(PRUint32 aRepeat)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute calIDuration repeatOffset; */
NS_IMETHODIMP _MYCLASS_::GetRepeatOffset(calIDuration * *aRepeatOffset)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetRepeatOffset(calIDuration * aRepeatOffset)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute calIDateTime repeatDate; */
NS_IMETHODIMP _MYCLASS_::GetRepeatDate(calIDateTime * *aRepeatDate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AUTF8String description; */
NS_IMETHODIMP _MYCLASS_::GetDescription(nsACString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetDescription(const nsACString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AUTF8String summary; */
NS_IMETHODIMP _MYCLASS_::GetSummary(nsACString & aSummary)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetSummary(const nsACString & aSummary)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AUTF8String icalString; */
NS_IMETHODIMP _MYCLASS_::GetIcalString(nsACString & aIcalString)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetIcalString(const nsACString & aIcalString)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute calIcalComponent icalComponent; */
NS_IMETHODIMP _MYCLASS_::GetIcalComponent(calIcalComponent * *aIcalComponent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetIcalComponent(calIcalComponent * aIcalComponent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean hasProperty (in AUTF8String name); */
NS_IMETHODIMP _MYCLASS_::HasProperty(const nsACString & name, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIVariant getProperty (in AUTF8String name); */
NS_IMETHODIMP _MYCLASS_::GetProperty(const nsACString & name, nsIVariant **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setProperty (in AUTF8String name, in nsIVariant value); */
NS_IMETHODIMP _MYCLASS_::SetProperty(const nsACString & name, nsIVariant *value)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void deleteProperty (in AUTF8String name); */
NS_IMETHODIMP _MYCLASS_::DeleteProperty(const nsACString & name)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsISimpleEnumerator propertyEnumerator; */
NS_IMETHODIMP _MYCLASS_::GetPropertyEnumerator(nsISimpleEnumerator * *aPropertyEnumerator)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_calIAlarm_h__ */
