/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM calISchedulingSupport.idl
 */

#ifndef __gen_calISchedulingSupport_h__
#define __gen_calISchedulingSupport_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class calIItemBase; /* forward declaration */

class calIAttendee; /* forward declaration */


/* starting interface:    calISchedulingSupport */
#define CALISCHEDULINGSUPPORT_IID_STR "9221e243-c97e-4c5f-9e00-5d7d3521bb44"

#define CALISCHEDULINGSUPPORT_IID \
  {0x9221e243, 0xc97e, 0x4c5f, \
    { 0x9e, 0x00, 0x5d, 0x7d, 0x35, 0x21, 0xbb, 0x44 }}

/**
 * Accesses scheduling specific information of calendar items.
 * Implementation by providers is optional.
 */
class NS_NO_VTABLE calISchedulingSupport : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(CALISCHEDULINGSUPPORT_IID)

  /**
     * Tests whether the passed item corresponds to an invitation, e.g.
     * the CUA or server has placed it in the calendar.
     *
     * @param aItem     Item to be tested.
     * @return          Whether the passed item corresponds to an invitation.
     */
  /* boolean isInvitation (in calIItemBase aItem); */
  NS_IMETHOD IsInvitation(calIItemBase *aItem, PRBool *_retval) = 0;

  /**
     * Gets the invited attendee if the passed item corresponds to
     * an invitation. UI code will use that attendee to modify e.g. PARTSTAT.
     * If isInvitation returns true, getInvitedAttendee must return
     * an attendee. If isInvitation is false, getInvitedAttendee may return
     * an attendee in case the organizer (and owner of the calendar) has
     * invited himself.
     *
     * @param aItem     Invitation item.
     * @return          Attendee object, or null.
     */
  /* calIAttendee getInvitedAttendee (in calIItemBase aItem); */
  NS_IMETHOD GetInvitedAttendee(calIItemBase *aItem, calIAttendee **_retval) = 0;

  /**
     * Checks whether the provider keeps track of sending out the proper
     * iTIP/iMIP message for a particular item.
     *
     * @param aMethod a iTIP method
     * @param aItem an item that has been modified/deleted etc.
     * @return true, if the provider keeps track of sending out passed message
     */
  /* boolean canNotify (in AUTF8String aMethod, in calIItemBase aItem); */
  NS_IMETHOD CanNotify(const nsACString & aMethod, calIItemBase *aItem, PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_CALISCHEDULINGSUPPORT \
  NS_IMETHOD IsInvitation(calIItemBase *aItem, PRBool *_retval); \
  NS_IMETHOD GetInvitedAttendee(calIItemBase *aItem, calIAttendee **_retval); \
  NS_IMETHOD CanNotify(const nsACString & aMethod, calIItemBase *aItem, PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_CALISCHEDULINGSUPPORT(_to) \
  NS_IMETHOD IsInvitation(calIItemBase *aItem, PRBool *_retval) { return _to IsInvitation(aItem, _retval); } \
  NS_IMETHOD GetInvitedAttendee(calIItemBase *aItem, calIAttendee **_retval) { return _to GetInvitedAttendee(aItem, _retval); } \
  NS_IMETHOD CanNotify(const nsACString & aMethod, calIItemBase *aItem, PRBool *_retval) { return _to CanNotify(aMethod, aItem, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_CALISCHEDULINGSUPPORT(_to) \
  NS_IMETHOD IsInvitation(calIItemBase *aItem, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsInvitation(aItem, _retval); } \
  NS_IMETHOD GetInvitedAttendee(calIItemBase *aItem, calIAttendee **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetInvitedAttendee(aItem, _retval); } \
  NS_IMETHOD CanNotify(const nsACString & aMethod, calIItemBase *aItem, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CanNotify(aMethod, aItem, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public calISchedulingSupport
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_CALISCHEDULINGSUPPORT

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, calISchedulingSupport)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* boolean isInvitation (in calIItemBase aItem); */
NS_IMETHODIMP _MYCLASS_::IsInvitation(calIItemBase *aItem, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* calIAttendee getInvitedAttendee (in calIItemBase aItem); */
NS_IMETHODIMP _MYCLASS_::GetInvitedAttendee(calIItemBase *aItem, calIAttendee **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean canNotify (in AUTF8String aMethod, in calIItemBase aItem); */
NS_IMETHODIMP _MYCLASS_::CanNotify(const nsACString & aMethod, calIItemBase *aItem, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_calISchedulingSupport_h__ */
